
#INCLUDE "HandleWalker.h"
/*
DEBUGLIB equ \Programming\RadASM3\GoAsm\dbg\Debug.lib
DEBUGEXE equ "\Programming\RadAsm\GoAsm\dbg\dbgwin.exe"

#include "\Programming\RadASM3\GoAsm\dbg\debug.a"
DBGWIN_DEBUG_ON = 0 // use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 // setting this to 1 will suppress PrintError if no error exists
*/

LOCAL_OBJECT_TYPE_INFORMATION STRUCT
	oti	PUBLIC_OBJECT_TYPE_INFORMATION <>
	ustring dw 128 DUP (?)
ends

LOCAL_OBJECT_NAME_INFORMATION STRUCT
	oti	UNICODE_STRING <>
	ustring dw 1024 DUP (?)
ends

DATA SECTION

hInstance	HANDLE	?
hThisProcess	HANDLE ?
hTreeview	HANDLE	?

CODE SECTION
Start:

invoke GetModuleHandle,NULL
mov [hInstance], eax

invoke GetCurrentProcess
mov [hThisProcess],eax

invoke InitCommonControls

invoke DialogBoxParam,[hInstance],1000,0,ADDR DialogProc,0

invoke ExitProcess,0

DialogProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx, esi, edi

	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_CLOSE
		invoke GetDlgItem,[hwnd],1001
		mov [hTreeview],eax
		invoke WalkProcesses
		mov eax,FALSE
		ret

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

WalkProcesses FRAME
	uses edi,ebx,esi
	LOCAL hProcess:%HANDLE
	LOCAL hHandles:%HANDLE
	LOCAL BytesNeeded:D
	LOCAL ProcessPath[MAX_PATH]:%CHAR
	LOCAL hParent:%HANDLE
	
	mov D[hParent],-1
	
	// Allocate memory for the handle array
	invoke GlobalAlloc,GMEM_FIXED,1024*1024
	mov [hHandles],eax
	
	invoke ntdll.dll:NtQuerySystemInformation, SystemHandleInformation, [hHandles], 1024*1024, offset BytesNeeded

	mov ebx, [hHandles]
	mov edi,[ebx] // Handle count
	add ebx,4 // skip past the count DWORD
	invoke qsort, ebx, edi , SIZEOF  SYSTEM_HANDLE_ENTRY, offset qsort_compare
	add esp,16

	:
	cmp esi,[ebx]
	je >>.SKIP
	invoke OpenProcess,PROCESS_QUERY_INFORMATION + PROCESS_VM_READ + PROCESS_DUP_HANDLE,FALSE,[ebx]
	mov [hProcess],eax
	test eax,eax
	jz >.SKIP
	// a new parent will be created so invalidate the old one
	mov D[hParent],-1
	invoke GetProcessImageFileName,[hProcess],offset ProcessPath,MAX_PATH
	// strip off the path
	push edi
	invoke StrLenSSE1, offset ProcessPath
	mov ecx,eax
	lea edi,[ProcessPath+eax]
	mov al,"\"
	std
	repne scasb
	cld
	inc edi
	inc edi
	invoke TreeviewAddProcess,[hTreeview],edi
	mov [hParent],eax
	// Walk the handles for this process
	invoke WalkHandles,[hTreeview],[hProcess],[hParent],ebx

	pop edi

	invoke CloseHandle,[hProcess]

	mov esi,[ebx]
	.SKIP
	add ebx,SIZEOF SYSTEM_HANDLE_ENTRY
	dec edi
	jnz <<

	invoke GlobalFree,[hHandles]
	ret
endf

WalkHandles FRAME hTrv, hProcess, hParent, pArray
	uses ebx,edi,esi
	LOCAL pid:D
	LOCAL hObject:%HANDLE
	LOCAL ObjTypeInfo:LOCAL_OBJECT_TYPE_INFORMATION
	LOCAL ObjNameInfo:LOCAL_OBJECT_NAME_INFORMATION
	LOCAL cbWritten:D
	LOCAL szType[256]:%CHAR
	LOCAL szFileName[MAX_PATH]:%CHAR
	LOCAL iostat:IO_STATUS_BLOCK
	LOCAL hChild:%HANDLE // used to add information to an objects entry if any

	mov ebx,[pArray]
	// Save the PID for this process
	push [ebx]
	pop [pid]

	:
	mov W[ObjTypeInfo.oti.TypeName.Length],0
	mov W[ObjTypeInfo.oti.TypeName.MaximumLength],128
	lea eax,ObjTypeInfo.ustring
	mov D[ObjTypeInfo.oti.TypeName.Buffer],eax

	movzx eax,W[ebx+SYSTEM_HANDLE_ENTRY.HandleValue]
	invoke DuplicateHandle,[hProcess],eax,[hThisProcess],offset hObject,NULL,NULL,2 ;DUPLICATE_SAME_ACCESS
	test eax,eax
	jz >>.exit
	invoke ntdll.dll:NtQueryObject,[hObject],ObjectTypeInformation,offset ObjTypeInfo,SIZEOF LOCAL_OBJECT_TYPE_INFORMATION,offset cbWritten
	lea eax,ObjTypeInfo
	mov esi,[eax+4]
	movzx eax, W[eax]
	invoke WideCharToMultiByte,CP_ACP,NULL,esi,eax,offset szType,256,NULL,NULL

	invoke TreeviewAddHandle,[hTreeview],[hParent],offset szType
	mov [hChild],eax

	// Get any name information
	invoke ntdll.dll:NtQueryObject,[hObject],ObjectNameInformation,offset ObjNameInfo,SIZEOF LOCAL_OBJECT_NAME_INFORMATION,offset cbWritten
	lea eax,ObjNameInfo
	add eax,4
	mov eax,[eax]
	test eax,eax
	jz >>.CLOSEHANDLE
	invoke WideCharToMultiByte,CP_ACP,NULL,eax,-1,offset szFileName,MAX_PATH,NULL,NULL
	invoke TreeviewAddHandle,[hTreeview],[hChild],offset szFileName

	.CLOSEHANDLE
	invoke CloseHandle,[hObject]
	// Get the next object
	add ebx,SIZEOF SYSTEM_HANDLE_ENTRY
	mov eax,[ebx]
	cmp eax,[pid]
	je <<

	.exit
	ret
endf

TreeviewAddProcess FRAME hTrv, pszTitle
	LOCAL	tvins			:TVINSERTSTRUCT

	mov D[tvins.hParent],TVI_ROOT
	mov D[tvins.hInsertAfter],TVI_LAST
	mov D[tvins.itemex.mask],TVIF_TEXT
	mov eax,[pszTitle]
	mov [tvins.itemex.pszText],eax

	invoke SendMessage,[hTrv],TVM_INSERTITEM,0,OFFSET tvins

    ret

ENDF

TreeviewAddHandle FRAME hTrv,hPar,pszTitle
	LOCAL	tvins			:TVINSERTSTRUCT

	mov eax,[hPar]
	mov [tvins.hParent],eax

	mov D[tvins.hInsertAfter],TVI_LAST
	mov D[tvins.itemex.mask],TVIF_TEXT
	mov eax,[pszTitle]
	mov [tvins.itemex.pszText],eax

	invoke SendMessage,[hTrv],TVM_INSERTITEM,0,OFFSET tvins

    ret

ENDF

qsort_compare:

	// Note that this is a C calling convention callback
	// Parameters passed to the callback are calculated as offsets from ESP (since there is no stack frame)
	// The CALL opcode pushes 4 bytes (return addr) so the parameters begin at ESP+4
	elem1	= esp+4
	elem2	= esp+8

	/*
	return values

	< 0	elem1 less than elem2
	0	elem1 equivalent to elem2
	> 0	elem1 greater than elem2

	*/

	mov eax,[elem1] // pointer to element 1
	mov ecx,[elem2] // pointer to element 2

	// These are a bit wasteful as the first element is what we need in this case
	// so the addressing mode is unecessary but it is more readable and allows
	// for simpler modification if we want to use a different sort key
	mov eax,[eax + SYSTEM_HANDLE_ENTRY.OwnerPid]
	mov ecx,[ecx + SYSTEM_HANDLE_ENTRY.OwnerPid]

	sub eax,ecx // Element 1 minus element 2 yeilds the desired return value
	neg eax // reverses the sort
	ret

StrLenSSE1:
	;int 3
	mov edx,[esp+4]
	mov eax,[esp+4]
	add esp,-14h
	movups [esp],xmm7
	mov [esp+16],ecx
	and edx,-10h
	mov ecx,0fh
	pxor xmm7,xmm7
	and ecx,eax
	jz >
	pcmpeqb xmm7,[edx]
	add edx,10h
	pmovmskb eax,xmm7
	shr eax,cl
	bsf eax,eax
	jnz >.ret
	:
	align 16
	:
	pcmpeqb xmm7,[edx]
	add edx,16
	pmovmskb eax,xmm7
	test eax,eax
	jz <	
	
	bsf eax,eax
	sub edx,[esp+4+16+4]
	lea eax,[eax+edx-10h]
	
	.ret
	movups xmm7,[esp]
	mov ecx,[esp+16]
	add esp,14h
	retn 4


