// Headers available at
// http://www.quickersoft.com/donkey/index.html

// NOTE: INCLUDE Environment variable must be set to headers path

// All functions, definitions and structures defined for Windows Vista
#DEFINE WINVER NTDDI_VISTA

// Filter API calls by Windows version
#DEFINE FILTERAPI

// Use ordinal exports for common controls
#DEFINE CCUSEORDINALS

// Automatically link dlls
#DEFINE LINKFILES

// use the visual C run time (for qsort)
#DEFINE LINKVCRT

// Use only the basic set of headers
#DEFINE WIN32_LEAN_AND_MEAN

// Winternl.h must be included before Windows.h otherwise it will not be loaded
#include "Winternl.h"

#include "WINDOWS.H"
#include "ntstatus.h"
#include "Commctrl.h"
#include "shlwapi.h"
#include "macros.h"

// Winternl.h disables psapi.h so we need to include stuff from that file manually

#IFDEF LINKFILES
	#dynamiclinkfile PSAPI.dll
#ENDIF

#IFDEF UNICODE
	#define GetModuleBaseName GetModuleBaseNameW
	#define GetModuleFileNameEx GetModuleFileNameExW
	#define GetMappedFileName GetMappedFileNameW
	#define GetDeviceDriverBaseName GetDeviceDriverBaseNameW
	#define GetDeviceDriverFileName GetDeviceDriverFileNameW
	#define EnumPageFiles EnumPageFilesW
	#define GetProcessImageFileName GetProcessImageFileNameW
#else
	#define GetModuleBaseName GetModuleBaseNameA
	#define GetModuleFileNameEx GetModuleFileNameExA
	#define GetMappedFileName GetMappedFileNameA
	#define GetDeviceDriverBaseName GetDeviceDriverBaseNameA
	#define GetDeviceDriverFileName GetDeviceDriverFileNameA
	#define EnumPageFiles EnumPageFilesA
	#define GetProcessImageFileName GetProcessImageFileNameA
#endif

#define PROCESS_TERMINATE  0x0001
#define PROCESS_CREATE_THREAD  0x0002
#define PROCESS_SET_SESSIONID  0x0004
#define PROCESS_VM_OPERATION  0x0008
#define PROCESS_VM_READ  0x0010
#define PROCESS_VM_WRITE  0x0020
#define PROCESS_DUP_HANDLE  0x0040
#define PROCESS_CREATE_PROCESS  0x0080
#define PROCESS_SET_QUOTA  0x0100
#define PROCESS_SET_INFORMATION  0x0200
#define PROCESS_QUERY_INFORMATION 0x0400
#define PROCESS_SUSPEND_RESUME 0x0800  
#define PROCESS_QUERY_LIMITED_INFORMATION 0x1000

#IF WINVER < NTDDI_VISTA
#define PROCESS_ALL_ACCESS  (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE|0xFFF)
#ELSE
#define PROCESS_ALL_ACCESS  (STANDARD_RIGHTS_REQUIRED|SYNCHRONIZE|0xFFFF)
#ENDIF

IO_STATUS_BLOCK STRUCT
	UNION
		Status DD
		Pointer DD
	ENDUNION
	Information DD
ENDS